//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace Tecan.Sila2.Interop.Server.StructureDataTypeTest
{
    
    
    /// <summary>
    /// Provides commands and properties to set or respectively get SiLA Structure Data Type values via command parameters or property responses respectively.
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "test")]
    [Tecan.Sila2.SilaIdentifierAttribute("StructureDataTypeTest")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Structure Data Type Test")]
    public partial interface IStructureDataTypeTest
    {
        
        /// <summary>
        /// Returns a structure with the following elements values:
        /// - String value = 'SiLA2_Test_String_Value'
        /// - Integer value = 5124
        /// - Real value = 3.1415926
        /// - Boolean value = true
        /// - Binary value = embedded string 'SiLA2_Binary_String_Value'
        /// - Date value = 05.08.2022 respective 08/05/2022
        /// - Time value = 12:34:56
        /// - Timestamp value = 2022-08-05 12:34:56
        /// - Any type value = string 'SiLA2_Any_Type_String_Value'.
        /// </summary>
        TestStructure StructureValue
        {
            get;
        }
        
        /// <summary>
        /// Returns a multilevel structure with the following values:
        /// - string value = 'Outer_Test_String'
        /// - integer value = 1111
        /// - middle structure value =
        /// - string value = 'Middle_Test_String'
        /// - integer value = 2222
        /// - inner structure value =
        /// - string value = 'Inner_Test_String'
        /// - integer value = 3333.
        /// </summary>
        DeepStructure DeepStructureValue
        {
            get;
        }
        
        /// <summary>
        /// Receives a structure value and returns the structure that has been received (binary value is expected to be an embedded value, any typer value is expected to be a Basic type).
        /// </summary>
        /// <param name="structureValue">The Structure value to be returned.</param>
        /// <returns>The structure that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValues")]
        TestStructure EchoStructureValue(TestStructure structureValue);
        
        /// <summary>
        /// Receives a multilevel structure value and returns the structure that has been received.
        /// </summary>
        /// <param name="deepStructureValue">The deep Structure value to be set.</param>
        /// <returns>The structure that has been received.</returns>
        [return: Tecan.Sila2.SilaIdentifierAttribute("ReceivedValues")]
        DeepStructure EchoDeepStructureValue([Tecan.Sila2.SilaDisplayNameAttribute("DeepStructure Value")] DeepStructure deepStructureValue);
    }
    
    /// <summary>
    /// An example Structure data type containing all SiLA basic types.
    /// </summary>
    public struct TestStructure
    {
        
        private string _stringTypeValue;
        
        private long _integerTypeValue;
        
        private double _realTypeValue;
        
        private bool _booleanTypeValue;
        
        private System.IO.Stream _binaryTypeValue;
        
        private System.DateTimeOffset _dateTypeValue;
        
        private System.TimeSpan _timeTypeValue;
        
        private System.DateTimeOffset _timestampTypeValue;
        
        private Tecan.Sila2.DynamicClient.DynamicObjectProperty _anyTypeValue;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public TestStructure(string stringTypeValue, long integerTypeValue, double realTypeValue, bool booleanTypeValue, System.IO.Stream binaryTypeValue, System.DateTimeOffset dateTypeValue, System.TimeSpan timeTypeValue, System.DateTimeOffset timestampTypeValue, Tecan.Sila2.DynamicClient.DynamicObjectProperty anyTypeValue)
        {
            _stringTypeValue = stringTypeValue;
            _integerTypeValue = integerTypeValue;
            _realTypeValue = realTypeValue;
            _booleanTypeValue = booleanTypeValue;
            _binaryTypeValue = binaryTypeValue;
            _dateTypeValue = dateTypeValue;
            _timeTypeValue = timeTypeValue;
            _timestampTypeValue = timestampTypeValue;
            _anyTypeValue = anyTypeValue;
        }
        
        /// <summary>
        /// A value of SiLA data type String.
        /// </summary>
        public string StringTypeValue
        {
            get
            {
                return _stringTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer.
        /// </summary>
        public long IntegerTypeValue
        {
            get
            {
                return _integerTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Real.
        /// </summary>
        public double RealTypeValue
        {
            get
            {
                return _realTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Boolean.
        /// </summary>
        public bool BooleanTypeValue
        {
            get
            {
                return _booleanTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Binary.
        /// </summary>
        public System.IO.Stream BinaryTypeValue
        {
            get
            {
                return _binaryTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Date.
        /// </summary>
        public System.DateTimeOffset DateTypeValue
        {
            get
            {
                return _dateTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Time.
        /// </summary>
        public System.TimeSpan TimeTypeValue
        {
            get
            {
                return _timeTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Timestamp.
        /// </summary>
        public System.DateTimeOffset TimestampTypeValue
        {
            get
            {
                return _timestampTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Any.
        /// </summary>
        public Tecan.Sila2.DynamicClient.DynamicObjectProperty AnyTypeValue
        {
            get
            {
                return _anyTypeValue;
            }
        }
    }
    
    /// <summary>
    /// An example Structure data type that contains other structures within.
    /// </summary>
    public struct DeepStructure
    {
        
        private string _outerStringTypeValue;
        
        private long _outerIntegerTypeValue;
        
        private DeepStructureMiddleStructure _middleStructure;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public DeepStructure(string outerStringTypeValue, long outerIntegerTypeValue, DeepStructureMiddleStructure middleStructure)
        {
            _outerStringTypeValue = outerStringTypeValue;
            _outerIntegerTypeValue = outerIntegerTypeValue;
            _middleStructure = middleStructure;
        }
        
        /// <summary>
        /// A value of SiLA data type String contained in the topmost structure.
        /// </summary>
        public string OuterStringTypeValue
        {
            get
            {
                return _outerStringTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer contained in the topmost structure.
        /// </summary>
        public long OuterIntegerTypeValue
        {
            get
            {
                return _outerIntegerTypeValue;
            }
        }
        
        /// <summary>
        /// Another structure type that is part of the outer structure.
        /// </summary>
        public DeepStructureMiddleStructure MiddleStructure
        {
            get
            {
                return _middleStructure;
            }
        }
    }
    
    /// <summary>
    /// The class DeepStructureMiddleStructureInnerStructure reflects an anonymous type from the feature definition.
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("DeepStructureMiddleStructureInnerStructure")]
    public struct DeepStructureMiddleStructureInnerStructure
    {
        
        private string _innerStringTypeValue;
        
        private long _innerIntegerTypeValue;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public DeepStructureMiddleStructureInnerStructure(string innerStringTypeValue, long innerIntegerTypeValue)
        {
            _innerStringTypeValue = innerStringTypeValue;
            _innerIntegerTypeValue = innerIntegerTypeValue;
        }
        
        /// <summary>
        /// A value of SiLA data type String contained in the innermost structure.
        /// </summary>
        public string InnerStringTypeValue
        {
            get
            {
                return _innerStringTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer contained in the innermost structure.
        /// </summary>
        public long InnerIntegerTypeValue
        {
            get
            {
                return _innerIntegerTypeValue;
            }
        }
    }
    
    /// <summary>
    /// The class DeepStructureMiddleStructure reflects an anonymous type from the feature definition.
    /// </summary>
    [Tecan.Sila2.SilaDisplayNameAttribute("DeepStructureMiddleStructure")]
    public struct DeepStructureMiddleStructure
    {
        
        private string _middleStringTypeValue;
        
        private long _middleIntegerTypeValue;
        
        private DeepStructureMiddleStructureInnerStructure _innerStructure;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public DeepStructureMiddleStructure(string middleStringTypeValue, long middleIntegerTypeValue, DeepStructureMiddleStructureInnerStructure innerStructure)
        {
            _middleStringTypeValue = middleStringTypeValue;
            _middleIntegerTypeValue = middleIntegerTypeValue;
            _innerStructure = innerStructure;
        }
        
        /// <summary>
        /// A value of SiLA data type String contained in the middle structure.
        /// </summary>
        public string MiddleStringTypeValue
        {
            get
            {
                return _middleStringTypeValue;
            }
        }
        
        /// <summary>
        /// A value of SiLA data type Integer contained in the middle structure.
        /// </summary>
        public long MiddleIntegerTypeValue
        {
            get
            {
                return _middleIntegerTypeValue;
            }
        }
        
        /// <summary>
        /// A structure type that is part of the middle structure.
        /// </summary>
        public DeepStructureMiddleStructureInnerStructure InnerStructure
        {
            get
            {
                return _innerStructure;
            }
        }
    }
}
